package ru.dbotthepony.mc.otm.datagen.blocks

import net.minecraft.world.level.block.Block
import net.minecraftforge.client.model.generators.BlockStateProvider
import net.minecraftforge.client.model.generators.ConfiguredModel
import net.minecraftforge.forge.event.lifecycle.GatherDataEvent
import ru.dbotthepony.mc.otm.datagen.DataGen

class SimpleBlockStateProvider(event: GatherDataEvent) : BlockStateProvider(event.generator, DataGen.MOD_ID, event.existingFileHelper) {
	private val blocks = ArrayList<Block>()
	private val ores = ArrayList<Block>()

	fun block(vararg blocks: Block) {
		this.blocks.addAll(blocks)
	}

	fun ore(vararg blocks: Block) {
		ores.addAll(blocks)
	}

	override fun registerStatesAndModels() {
		for (block in blocks) {
			getVariantBuilder(block).forAllStates {
				check(block.registryName != null) {"$block registry name is null!"}
				return@forAllStates arrayOf(ConfiguredModel(models().getExistingFile(block.registryName)))
			}
		}

		for (block in ores) {
			var first = true

			getVariantBuilder(block).forAllStates {
				check(first) {"$block has more than one BlockState"}
				first = false

				check(block.registryName != null) {"$block registry name is null!"}
				val localModel = models().getExistingFile(block.registryName)

				val generated = ArrayList<ConfiguredModel>()

				for (x in arrayOf(0, 90, 180)) {
					for (y in arrayOf(0, 90, 180, 270)) {
						generated.add(with(ConfiguredModel.builder()) {
							rotationX(x)
							rotationY(y)
							modelFile(localModel)
							return@with buildLast()
						})
					}
				}

				return@forAllStates generated.toTypedArray()
			}
		}
	}
}
